﻿using System;

public class Program
{
    public static void Main()
    {
        Switch foo1 = new Switch("A", true);
        Switch foo2 = new Switch("B", true);

        //if (foo1)
        //{
        //    Console.WriteLine($"{foo1.Name} ON");
        //}

        //if (foo2)
        //{
        //    Console.WriteLine($"{foo2.Name} ON");
        //}

        //if (foo1 && foo2)
        //{
        //    Console.WriteLine("If");
        //}

        if (foo1 || foo2)
        {
            Console.WriteLine("If");
        }
    }
}

class Switch
{
    public string Name { get; private set; }
    public bool On { get; private set; }

    public Switch(string name, bool on)
    {
        Name = name;
        On = on;
    }

    public static bool operator true(Switch t)
    {
        Console.WriteLine($"{t.Name} op.True");
        return t.On;
    }

    public static bool operator false(Switch t)
    {
        Console.WriteLine($"{t.Name} op.False");
        return t.On == false;
    }

    public static Switch operator &(Switch lhs, Switch rhs)
    {
        Console.WriteLine($"{lhs.Name} & {rhs.Name}");

        if (lhs.On == false)
        {
            return lhs;
        }

        return rhs;
    }

    public static Switch operator |(Switch lhs, Switch rhs)
    {
        Console.WriteLine($"{lhs.Name} & {rhs.Name}");

        if (lhs.On == true)
        {
            return lhs;
        }

        return rhs;
    }
}