﻿using System;
using System.Runtime.Serialization;

public class Program
{
    public static void Main()
    {
        Foo foo = new Foo();

        var ctor = typeof(Foo).GetConstructor(new Type[0]);
        
        ctor.Invoke(foo, new object[0]);
        ctor.Invoke(foo, new object[0]);
        ctor.Invoke(foo, new object[0]);

        Foo o = FormatterServices.GetUninitializedObject(typeof(Foo)) as Foo;
        ctor.Invoke(o, new object[0]);
        Console.WriteLine(o.n);
    }
}

class Foo
{
    public int n = 5;

    public Foo()
    {
        Console.WriteLine("Constructor!");
    }
}