﻿using System;
using System.Runtime.Remoting.Proxies;
using System.Runtime.Serialization;

namespace ConsoleApp
{
    class Program
    {
        public static void Main()
        {
            var instance = new Foo();
            Console.WriteLine(instance == null);
        }
    }

    class FooProxyAttribute : ProxyAttribute
    {
        public override MarshalByRefObject CreateInstance(Type serverType)
        {
            Console.WriteLine("Custom new");

            // return base.CreateInstance(serverType);

            return null;
        }
    }


    [FooProxy]
    class Foo : ContextBoundObject { }
}